definition module GameLibrary

import StdGame
import StdGameDef
import StdProcess
import gameintrface_12

OBJ_AUTOINIT  :==  0


//:: GameStateFunction :== *(GSt DefaultGameState) -> *(GSt DefaultGameState)


defaultGame :: .(Game DefaultGameState) [.GameAttribute DefaultGameState] !*World -> .World


::  DefaultGameState
    = { curlevel    :: Int
      , maxlevel    :: Int
      , quit        :: Bool

      }

defaultGameDef :: [Level (GSt DefaultGameState)] -> (Game DefaultGameState)

quitlevel :: !*(GameObjectState a *(GSt DefaultGameState)) -> *GameObjectState a *(GSt DefaultGameState)
 
defaultGameLevel :: !(Maybe .Colour) ![.Layer] !.BoundMap !.[GameObject (*GSt .a)] (IdFun (*GSt .a)) [SoundSample] -> (.Level (*GSt .a))

emptyMap :: BoundMap

defaultBoundMap :: !Size !Size ![(Point2, Int)] -> BoundMap

newObject :: ObjectCode Size [Sprite] (Point2 -> GameObjectRec -> GameObjectRec) -> (GameObject (GSt a))

createGameObject :: !ObjectCode !Point2 !(GSt .gs) -> (GSt .gs)

noInstances :: *(GSt .gs) -> *(GSt .gs)

defaultTransparentSprite :: !String !Size !Point2 -> Sprite

defaultSprite :: !String !Size -> Sprite

sound :: !Int !*(GSt .gs) -> *(GSt .gs)
